/*
  apl2.c

  Make table of the IBM APL2 character set.

  Unicode mappings according to ISO-IEC / JTC 1 / SC 22 N 3067, 1999-12-28.
  Confusion with TACK symbols reflects confusion in the various APL sets as
  to whether the head or the point is the top.
  
  F. da Cruz, Columbia University, July 2000.
*/
struct charinfo {
    unsigned short uc;
    char * name

} info[] = {  
    0x00c7, "LATIN CAPITAL LETTER C WITH CEDILLA",
    0x00fc, "LATIN SMALL LETTER U WITH DIAERESIS",
    0x00e9, "LATIN SMALL LETTER E WITH ACUTE ACCENT",
    0x00e2, "LATIN SMALL LETTER A WITH CIRCUMFLEX",
    0x00e4, "LATIN SMALL LETTER A WITH DIAERESIS",
    0x00e0, "LATIN SMALL LETTER A WITH GRAVE ACCENT",
    0x00e5, "LATIN SMALL LETTER A WITH RING ABOVE",
    0x00e7, "LATIN SMALL LETTER C WITH CEDILLA",
    0x00ea, "LATIN SMALL LETTER E WITH CIRCUMFLEX",
    0x00eb, "LATIN SMALL LETTER E WITH DIAERESIS",
    0x00e8, "LATIN SMALL LETTER E WITH GRAVE ACCENT",
    0x00ef, "LATIN SMALL LETTER I WITH DIAERESIS",
    0x00ee, "LATIN SMALL LETTER I WITH CIRCUMFLEX",
    0x00ec, "LATIN SMALL LETTER I WITH GRAVE ACCENT",
    0x00c4, "LATIN CAPITAL LETTER A WITH DIAERESIS",
    0x00c5, "LATIN CAPITAL LETTER A WITH RING ABOVE",
    0x25af, "QUAD",
    0x235e, "QUOTE QUAD",
    0x2339, "QUAD DIVIDE",
    0x00f4, "LATIN SMALL LETTER O WITH CIRCUMFLEX", 
    0x00f6, "LATIN SMALL LETTER O WITH DIAERESIS",
    0x00f2, "LATIN SMALL LETTER O WITH GRAVE ACCENT",
    0x00fb, "LATIN SMALL LETTER U WITH CIRCUMFLEX",    
    0x00f9, "LATIN SMALL LETTER U WITH GRAVE ACCENT",
    0x22a4, "UP (DOWN) TACK",
    0x00d6, "LATIN CAPITAL LETTER O WITH DIAERESIS",
    0x00dc, "LATIN CAPITAL LETTER U WITH DIAERESIS",
    0x00f8, "LATIN SMALL LETTER O WITH OBLIQUE STROKE",
    0x00a3, "POUND SIGN",
    0x22a5, "DOWN (UP) TACK",
    0x2190, "LEFT ARROW",
    0x2336, "I-BEAM",
    0x00e1, "LATIN SMALL LETTER A WITH ACUTE ACCENT",
    0x00ed, "LATIN SMALL LETTER I WITH ACUTE ACCENT",
    0x00f3, "LATIN SMALL LETTER O WITH ACUTE ACCENT",
    0x00fa, "LATIN SMALL LETTER U WITH ACUTE ACCENT",
    0x00f1, "LATIN SMALL LETTER N WITH TILDE",
    0x00d1, "LATIN CAPITAL LETTER N WITH TILDE",
    0x00aa, "FEMININE ORDINAL INDICATOR",
    0x00ba, "MASCULINE ORDINAL INDICATOR",
    0x00bf, "INVERTED QUESTION MARK",
    0x2308, "UP STILE",
    0x00ac, "NOT SIGN",
    0x2192, "RIGHT ARROW",
    0x222a, "DOWN SHOE",
    0x00a1, "INVERTED EXCLAMATION MARK",
    0x2355, "UP (DOWN) TACK JOT",
    0x234e, "DOWN (UP) TACK JOT",
    0x2591, "FILL CHARACTER LIGHT (LIGHT SHADE)",
    0x2592, "FILL CHARACTER MEDIUM (MEDIUM SHADE)",
    0x2593, "FILL CHARACTER HEAVY (DARK SHADE)",
    0x2502, "BOX DRAWINGS VERTICAL",
    0x2524, "BOX DRAWINGS VERTICAL AND LEFT",
    0x235f, "CIRCLE STAR",
    0x2206, "DELTA",
    0x2207, "DEL",
    0x2192, "RIGHT ARROW",
    0x2563, "BOX DRAWINGS DOUBLE VERTICAL AND LEFT",
    0x2551, "BOX DRAWINGS DOUBLE VERTICAL",
    0x2557, "BOX DRAWINGS DOUBLE DOWN AND LEFT",
    0x255d, "BOX DRAWINGS DOUBLE UP AND LEFT",
    0x2190, "LEFT ARROW",
    0x230a, "DOWN STILE",
    0x2510, "BOX DRAWINGS UPPER RIGHT CORNER",
    0x2514, "BOX DRAWINGS LOWER LEFT CORNER",
    0x2534, "BOX DRAWINGS UP AND HORIZONTAL",
    0x252c, "BOX DRAWINGS DOWN AND HORIZONTAL",
    0x251c, "BOX DRAWINGS VERTICAL AND RIGHT",
    0x2500, "BOX DRAWINGS HORIZONTAL",
    0x253c, "BOX DRAWINGS VERTICAL HORIZONTAL INTERSECTION",
    0x2191, "UP ARROW",
    0x2193, "DOWN ARROW",
    0x255a, "BOX DRAWINGS DOUBLE UP AND RIGHT",
    0x2554, "BOX DRAWINGS DOUBLE DOWN AND RIGHT",
    0x2569, "BOX DRAWINGS DOUBLE UP AND HORIZONTAL",
    0x2566, "BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL",
    0x2560, "BOX DRAWINGS DOUBLE VERTICAL AND RIGHT",
    0x2550, "BOX DRAWINGS DOUBLE HORIZONTAL",
    0x256c, "BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL",
    0x2261, "MATCH",
    0x2378, "IOTA UNDERBAR",
    0x2377, "EPSILON UNDERBAR",
    0x2235, "DIAERESIS DOT",
    0x2337, "SQUISH QUAD",
    0x2342, "QUAD BACKSLASH",
    0x233b, "QUAD JOT",
    0x22a2, "LEFT (RIGHT) TACK",
    0x22a3, "RIGHT (LEFT) TACK",
    0x22c4, "DIAMOND",
    0x2518, "BOX DRAWINGS LOWER RIGHT CORNER",
    0x250c, "BOX DRAWINGS UPPER LEFT CORNER",
    0x2588, "FULL BLOCK, BLACK SQUARE",
    0x2584, "LOWER HALF BLOCK",
    0x00a6, "BROKEN BAR",
    0x00cc, "LATIN CAPITAL LETTER I WITH GRAVE ACCENT",
    0x2580, "UPPER HALF BLOCK",
    0x237a, "ALPHA",
    0x00df, "LATIN SMALL LETTER SHARP S",
    0x2282, "LEFT SHOE",
    0x2283, "RIGHT SHOE",
    0x235d, "UP SHOE JOT",
    0x2372, "UP CARET TILDE",
    0x2374, "RHO",
    0x2371, "DOWN CARET TILDE",
    0x233d, "CIRCLE STILE",
    0x2296, "CIRCLE BAR",
    0x25cb, "CIRCLE",
    0x2228, "DOWN CARET",
    0x2373, "IOTA",
    0x2349, "CIRCLE BACKSLASH",
    0x00c5, "LATIN CAPITAL LETTER A WITH RING ABOVE",
    0x2229, "UP SHOE",
    0x233f, "SLASH BAR",    
    0x2340, "BACKSLASH BAR",
    0x2265, "GREATER THAN OR EQUAL SIGN",
    0x2264, "LESS THAN OR EQUAL SIGN",
    0x2260, "NOT-EQUAL SIGN",
    0x00d7, "MULTIPLICATION SIGN",
    0x00f7, "DIVIDE SIGN",
    0x2359, "DELTA UNDERBAR",
    0x2218, "JOT",
    0x2375, "OMEGA",
    0x236b, "DEL TILDE",
    0x234b, "DELTA STILE",
    0x2352, "DEL STILE",
    0x00af, "OVERBAR, MACRON",
    0x00a8, "DIAERESIS",
    0x00a0, "NO-BREAK SPACE",
    0, ""
};

main() {
    int i, j;
    printf("IBM APL2\n");
    printf("char dec col/row oct hex unicod description\n");
    for (i = 128; i < 256; i++) {
	j = i - 128;
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %04X  %s\n",
	       i, i, i/16, i%16, i, i, (unsigned int)info[j].uc, info[j].name);
    }
}
